<template>
  <header
    class="z-20 bg-white"
    :class="{
      'is-mega-menu': isMegaMenu,
      'py-0 fixed w-full top-0 left-0 shadow-1': isSticky
    }"
  >
    <div
      v-show="!isMobile"
      class="topbar relative z-10 bg-white"
      :class="[isSticky ? 'py-px' : 'py-4']"
    >
      <div class="container">
        <div class="flex items-center">
          <div class="logo mr-auto">
            <nuxt-link to="/" class="inline-block align-top">
              <img src="/logo-desktop.svg" alt="logo" />
            </nuxt-link>
          </div>
          <TheNavigation :is-mega-menu.sync="isMegaMenu" />
          <div class="ml-6 pl-6 border-l border-gray-light relative">
            <client-only>
              <div v-if="!isAuth" class="flex items-center">
                <div>
                  <span class="font-normal text-base text-dark-blue">
                    Đăng nhập
                  </span>
                </div>
                <ul class="flex ml-3 text-dark-blue">
                  <li>
                    <a
                      href="javascript:;"
                      class="inline-block bg-gray-light w-36px h-36px text-center leading-225"
                    >
                      <svg-icon
                        class="w-6 h-6 inline-block align-middle"
                        name="icon-apple"
                      />
                    </a>
                  </li>
                  <li class="ml-3">
                    <a
                      href="javascript:;"
                      class="inline-block bg-gray-light w-36px h-36px text-center leading-225"
                    >
                      <svg-icon
                        class="w-6 h-6 inline-block align-middle"
                        name="icon-google"
                      />
                    </a>
                  </li>
                  <li class="ml-3">
                    <a
                      href="javascript:;"
                      class="inline-block bg-gray-light w-36px h-36px text-center leading-225"
                    >
                      <svg-icon
                        class="w-6 h-6 inline-block align-middle"
                        name="icon-facebook-1"
                      />
                    </a>
                  </li>
                </ul>
              </div>
              <div v-else class="flex items-center">
                <nuxt-link :to="{ name: 'account' }">
                  <Avatar :type="'small'" :avatar="'/users/avatar-1.png'" />
                </nuxt-link>
                <a
                  class="relative inline-block ml-4 bg-gray-light w-8 h-8 text-center leading-225 text-base cursor-pointer"
                  :class="[
                    isNotification
                      ? 'bg-blue text-white'
                      : 'bg-gray-light text-dark-blue'
                  ]"
                  @click="isNotification = !isNotification"
                >
                  <svg-icon
                    name="icon-notification"
                    class="h-5 w-5 inline-block align-middle"
                  ></svg-icon>
                  <span
                    class="absolute w-4 h-4 rounded-full text-white bg-red font-bold text-9px text-center"
                    style="top: -5px;right: -5px; line-height: 17px; font-size: 9px;"
                  >
                    12
                  </span>
                </a>
              </div>
              <TheNotification :is-notification.sync="isNotification" />
            </client-only>
          </div>
        </div>
      </div>
    </div>
    <div
      v-show="isMobile"
      class="topbar-mobile flex items-center justify-between px-4 py-3"
    >
      <div class="logo mr-auto">
        <nuxt-link to="/" class="inline-block align-top">
          <img src="/logo-mobile.svg" alt="logo" />
        </nuxt-link>
      </div>
      <div class="btn-control-menu cursor-pointer">
        <svg-icon class="w-8 h-8 text-dark-blue" name="icon-menu" />
      </div>
    </div>
  </header>
</template>

<script>
export default {
  name: 'TheHeader',
  components: {
    Avatar: () => import('~/components/common/Avatar'),
    TheNavigation: () =>
      import('~/components/layout-default/the-header/TheNavigation'),
    TheNotification: () =>
      import('~/components/layout-default/the-header/TheNotification')
  },
  data() {
    return {
      isAuth: true,
      isMegaMenu: false,
      isSticky: false,
      isNotification: false
    }
  },
  computed: {
    isMobile() {
      return this.$store.getters.isMobile
    }
  },
  watch: {
    isNotification(value) {
      const body = document.getElementsByTagName('body')[0]
      if (value) {
        body.classList.add('overflow-hidden')
      } else {
        body.classList.remove('overflow-hidden')
      }
    }
  },
  mounted() {
    window.addEventListener('scroll', this.sticky)
    this.sticky()
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.sticky)
  },
  methods: {
    sticky() {
      if (window.pageYOffset > 150) {
        this.isSticky = true
      } else {
        this.isSticky = false
      }
    }
  }
}
</script>
<style lang="scss">
header {
  &.is-mega-menu {
    &:after {
      content: '';
      background: #000;
      position: fixed;
      width: 100%;
      height: 100vw;
      opacity: 0.5;
      top: 0;
      z-index: 1;
    }
  }
}
.ps {
  height: 598px;
  padding-right: 16px;
}
/* Custom scroll */
.ps {
  overflow: hidden !important;
  overflow-anchor: none;
  -ms-overflow-style: none;
  touch-action: auto;
  -ms-touch-action: auto;
  position: relative;
}
.ps__rail-x {
  display: none;
  opacity: 0;
  transition: background-color 0.2s linear, opacity 0.2s linear;
  -webkit-transition: background-color 0.2s linear, opacity 0.2s linear;
  height: 15px;
  bottom: 0px;
  position: absolute;
}
.ps__rail-y {
  display: none;
  opacity: 0;
  transition: background-color 0.2s linear, opacity 0.2s linear;
  -webkit-transition: background-color 0.2s linear, opacity 0.2s linear;
  width: 10px;
  right: 0;
  position: absolute;
}
.ps--active-x > .ps__rail-x,
.ps--active-y > .ps__rail-y {
  display: block;
  background-color: transparent;
}
.ps:hover > .ps__rail-x,
.ps:hover > .ps__rail-y,
.ps--focus > .ps__rail-x,
.ps--focus > .ps__rail-y,
.ps--scrolling-x > .ps__rail-x,
.ps--scrolling-y > .ps__rail-y {
  opacity: 1;
}
.ps .ps__rail-x:hover,
.ps .ps__rail-y:hover,
.ps .ps__rail-x:focus,
.ps .ps__rail-y:focus,
.ps .ps__rail-x.ps--clicking,
.ps .ps__rail-y.ps--clicking {
  background-color: #fff;
  opacity: 0.9;
}
.ps__thumb-x {
  background-color: #eff0f4;
  border-radius: 6px;
  transition: background-color 0.2s linear, height 0.2s ease-in-out;
  -webkit-transition: background-color 0.2s linear, height 0.2s ease-in-out;
  height: 6px;
  bottom: 2px;
  position: absolute;
}
.ps__thumb-y {
  background-color: #eff0f4;
  border-radius: 6px;
  transition: background-color 0.2s linear, width 0.2s ease-in-out;
  -webkit-transition: background-color 0.2s linear, width 0.2s ease-in-out;
  width: 8px;
  right: 2px;
  position: absolute;
}
.ps__rail-x:hover > .ps__thumb-x,
.ps__rail-x:focus > .ps__thumb-x,
.ps__rail-x.ps--clicking .ps__thumb-x {
  background-color: #999;
  height: 8px;
}
.ps__rail-y:hover > .ps__thumb-y,
.ps__rail-y:focus > .ps__thumb-y,
.ps__rail-y.ps--clicking .ps__thumb-y {
  background-color: #999;
  width: 8px;
}
/* MS supports */
@supports (-ms-overflow-style: none) {
  .ps {
    overflow: auto !important;
  }
}
@media screen and (-ms-high-contrast: active), (-ms-high-contrast: none) {
  .ps {
    overflow: auto !important;
  }
}
</style>
